unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, XPMan, ExtCtrls,SubUnit, ComCtrls;

type
  TForm1 = class(TForm)
    Pere1: TMemo;
    Pri1: TMemo;
    Pere2: TMemo;
    Pri2: TMemo;
    Button1: TButton;
    Find: TButton;
    NormalATH: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenM: TBitBtn;
    NoCom: TComboBox;
    XPManifest1: TXPManifest;
    Shape1: TShape;
    Free: TBitBtn;
    CloseM: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Number: TEdit;
    Call: TBitBtn;
    Status: TStatusBar;
    Timer1: TTimer;
    BitRate: TComboBox;
    procedure Button1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure NumberKeyPress(Sender: TObject; var Key: Char);
    procedure FindClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FreeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenMClick(Sender: TObject);
    procedure CloseMClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Pere1KeyPress(Sender: TObject; var Key: Char);
    procedure Pere2KeyPress(Sender: TObject; var Key: Char);
    procedure CallClick(Sender: TObject);
    procedure NormalATHClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
 Pri1.Clear;
 Pere1.Clear;
end;

procedure TForm1.BitBtn5Click(Sender: TObject);
begin
 Pri2.Clear;
 Pere2.Clear;
end;

procedure TForm1.NumberKeyPress(Sender: TObject; var Key: Char);
begin
 if Key in ['0'..'9','+',#8] then else Key:=#0;
end;

procedure TForm1.FindClick(Sender: TObject);
begin
 if not OpenCom(NoCom.ItemIndex,BitRate.ItemIndex)
    then
    begin
    ShowMessage(''+inttostr((NoCom.ItemIndex+1))+'    !');
    exit;
    end;

 CloseMux;
 sleep(ComTimeOut);
 ReadBuf;
 ClearBuf;

 WriteAT('AT');
 Sleep(ComTimeOut);
 Readbuf;

 if not OKIn then
 begin
 ClearBuf;
 Showmessage('  !   .');
 CloseCom;
 exit;
 end;

 ClearBuf;

Free.Enabled:=true;
Find.Enabled:=false;
NoCom.Enabled:=false;
OpenM.Enabled:=true;
Status.SimpleText:=' ';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 CloseCom;
end;

procedure TForm1.FreeClick(Sender: TObject);
begin
 CloseCom;
 Find.Enabled:=true;
 NoCom.Enabled:=true;
 Free.Enabled:=false;
 OpenM.Enabled:=false;
 Status.SimpleText:=' ';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Status.SimpleText:=' ';
end;


procedure TForm1.OpenMClick(Sender: TObject);
begin
 OpenMux;
 Sleep(ComTimeOut);
 OpenChanel(Channel0);
 Sleep(ComTimeOut);
 ReadBuf;
 if (PaketIn)and(TypePaket=tpUA) then
  begin
  OpenM.Enabled:=false;
  CloseM.Enabled:=true;
  Free.Enabled:=false;

  Pere1.Enabled:=true;
  Pere2.Enabled:=true;

  Status.SimpleText:='  ';



  ClearBuf;
  OpenChanel(Channel1);
  Sleep(ComTimeOut);
  ReadBuf;
  if (PaketIn)and(TypePaket=tpUA) then
            else
            ShowMessage('    !');
  ClearBuf;

  OpenChanel(Channel2);
  Sleep(ComTimeOut);
  ReadBuf;
  if (PaketIn)and(TypePaket=tpUA) then
            else
            ShowMessage('    !');


  ClearBuf;
  Timer1.Enabled:=true;
  Call.Enabled:=true;
  NormalATH.Enabled:=true;
  exit;
  end;
 ShowMessage('    !');
 ClearBuf;
end;

procedure TForm1.CloseMClick(Sender: TObject);
begin
 Timer1.Enabled:=false;
 CloseMux;
 Sleep(ComTimeOut);
 ReadBuf;

 if (PaketIn)and(TypePaket=tpUIH) then
  begin
  OpenM.Enabled:=true;
  CloseM.Enabled:=false;
  Free.Enabled:=true;
  Status.SimpleText:=' ';

  OpenM.Enabled:=true;
  CloseM.Enabled:=false;
  Free.Enabled:=true;
  Pere1.Enabled:=false;
  Pere2.Enabled:=false;
  Call.Enabled:=false;
  NormalATH.Enabled:=false;
  ClearBuf;
  exit;
  end;
 ShowMessage('    !');
 ClearBuf;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
 var n:word;
begin

 n:=DataInCom;

 While(n>0) do
  begin
  ReadChar;
  Dec(n);
  if PaketIn then
BEGIN
ClearBuf;

if TypePaket<>tpUIH then continue;

if CurrentChannel=1 then
                   Pri1.Text:=Pri1.Text+PaketData;

if CurrentChannel=2 then
                   Pri2.Text:=Pri2.Text+PaketData;

END;

  end;

end;

procedure TForm1.Pere1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key<>#8 then SendData(Channel1,Key) else Key:=#0;
end;

procedure TForm1.Pere2KeyPress(Sender: TObject; var Key: Char);
begin
if Key<>#8 then SendData(Channel2,Key) else Key:=#0;
end;

procedure TForm1.CallClick(Sender: TObject);
begin
 SendData(Channel1,'atd'+Number.Text+#13);
end;

procedure TForm1.NormalATHClick(Sender: TObject);
begin
 SendData(Channel2,'ath'+#13);
end;

end.
